#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <conio.h>
#include <fcntl.h>
#include <dir.h>
#include <mem.h>
#include <alloc.h>
#include <dos.h>
#include <sys\stat.h>
#include <share.h>
#include <math.h>
#include <float.h>
#include <time.h>
#include <values.h>

#define BUFSIZE 10240U

void say(int attr,int row,int col,char *msg);

int aborted=0;
int check=0;

long minfreeram=MAXLONG;

/*--- SOUND --------------------------------------------------------*/

void beeper(int f, int d)
{
   sound(f); delay(d); nosound();
}

void beep() {
   beeper(1000,25);
}

void boop() {
   beeper(300,100);
}

/*--- KEYBOARD -----------------------------------------------------*/

#define ESCAPE 27
#define ENTER 13
#define BIGENTER 10
#define BACKSPACE 8
#define RUBOUT 8
#define BLANK 32
#define SPACE 32
#define RIGHT 256+77
#define LEFT 256+75
#define HOME 256+71
#define END 256+79
#define UP 256+72
#define DOWN 256+80
#define INSERT 256+82
#define DELETE 256+83
#define CTRLEND 256+117
#define BIGRIGHT 256+116
#define BIGLEFT 256+115
#define PGUP 256+73
#define PGDN 256+81
#define F1 256+59
#define F2 F1+1
#define F3 F1+2
#define F4 F1+3
#define F5 F1+4
#define F6 F1+5
#define F7 F1+6
#define F8 F1+7
#define F9 F1+8
#define F10 F1+9
#define sF1 256+84
#define sF2 sF1+1
#define sF3 sF1+2
#define sF4 sF1+3
#define sF5 sF1+4
#define sF6 sF1+5
#define sF7 sF1+6
#define sF8 sF1+7
#define sF9 sF1+8
#define sF10 sF1+9
#define cF1 256+94
#define cF2 cF1+1
#define cF3 cF1+2
#define cF4 cF1+3
#define cF5 cF1+4
#define cF6 cF1+5
#define cF7 cF1+6
#define cF8 cF1+7
#define cF9 cF1+8
#define cF10 cF1+9
#define aF1 256+104
#define aF2 aF1+1
#define aF3 aF1+2
#define aF4 aF1+3
#define aF5 aF1+4
#define aF6 aF1+5
#define aF7 aF1+6
#define aF8 aF1+7
#define aF9 aF1+8
#define aF10 aF1+9
#define TAB 9
#define BACKTAB 256+15
#define ABORTKEY ESCAPE
#define AltP 256+25
#define CtrlP 16

int INSERTMODE = 1;

#define setcursor() _setcursortype( INSERTMODE ? _NORMALCURSOR : _SOLIDCURSOR )
#define cursor_on() setcursor()
#define cursor_off() _setcursortype( _NOCURSOR )

int getkey() {
   int c;
   if ((c = getch())==0)
       c = getch() + 256;
   return(c);
}

/*--- DISPLAY --------------------------------------------*/

#define COLORATTR(f,b) (f) + ((b) << 4)

void say(int attr,int row,int col,char *msg) {
   gotoxy(col,row);
   textattr(attr);
   cputs(msg);
}

/*-- other stuff -------------------------------------------------*/

void Exit(int exitcode) {
   window(1,1,80,25);
   textattr(LIGHTGRAY);
   if (!exitcode)
      clrscr();
   gotoxy(1,24);
   _setcursortype(_NORMALCURSOR);
   exit(exitcode);
}

void *getmemory(unsigned nbytes)
{
   void *heap;
   long whatsleft;
   if (nbytes==0U || nbytes > 65000U) {
      printf("\nAttempt to allocate %u bytes failed.\n\nExiting to DOS..\n",nbytes);
      Exit(1);
   }
   heap = malloc(nbytes);
   whatsleft=coreleft();
   minfreeram=min(minfreeram, whatsleft);
   if (heap == NULL) {
      printf("\n\nSorry, only %lu bytes left in RAM.",whatsleft);
      printf("\nAttempt to allocate %u bytes failed.\n\nExiting to DOS..\n",nbytes);
      Exit(1);
   }
   memset(heap,0,nbytes);
   return(heap);
}

#define nulmemory(n) getmemory(n)

void check_aborted() {
   while (kbhit())
      if (getch()==27)
         aborted=1;
}

typedef struct {
   FILE *stream;
   char *filename;
   char *buf;
   unsigned n;
   int eof;
} File;

File *Fopen(char *fn,char *m) {
   File *f;
   FILE *g;
   g=fopen(fn,m);
   if (g) {
      f=(File *)getmemory(sizeof(File));
      f->filename=(char *)getmemory(strlen(fn)+1);
      f->buf=(char *)getmemory(BUFSIZE);
      f->stream=g;
      strcpy(f->filename,fn);
      setvbuf(f->stream,f->buf,_IOFBF,BUFSIZE);
      f->eof=0;
      f->n=0;
   } else
      f=NULL;
   return f;
}

void *Fclose(File *f) {
   fclose(f->stream);
   free(f->filename);
   free(f->buf);
   free(f->stream);
   free(f);
   return NULL;
}

void Fnewline(File *f) {
   fprintf(f->stream,"\n");
   f->n++;
}

void Fzap(File *f) {
   if (f) {
      fclose(f->stream);
      unlink(f->filename);
      free(f->buf);
      free(f->filename);
      free(f);
   }
}

void Fwrite(File *f,char *s) {
   fprintf(f->stream,"%s\n",s);
}

void pause() {
   printf("\n\npress any key..");
   getch();
}

void strip(char *s,int n) {
   while (s[n]<=' '&&n>=0)
      s[n--]=0;
}

#define SINGLEQUOTE 39
#define DOUBLEQUOTE 34
#define APOSTROPHE 96

void unquote(char *s) {
   int i,j,L;
   char *t;
   
   L=strlen(s);
   t=(char *)nulmemory(L);
   
   j=0;
   for (i=0; i<L; i++)
      if (s[i] != SINGLEQUOTE &&
          s[i] != DOUBLEQUOTE &&
          s[i] != APOSTROPHE)
         t[j++]=s[i];
   
   memset(s,0,L);

   for (i=0; i<j; i++)
      s[i]=t[i];

   free(t);
}

int matherr(struct exception *e)
{
   if (e->type == UNDERFLOW) {
      /* flush underflow to 0 */
      e->retval = 0;
      return 1;
   } else {
      window(1,1,80,25);
      textattr(WHITE);
      clrscr();
      printf("\n\nMath error: type=%d name=%s\n\n",e->type,e->name);
      if (e->type == TLOSS) {
         /* total loss of FPPREC, but ignore the problem */
         return 1;
      } else {
         if (e->type == EDOM) {
            printf("\n\nMATH FUNCTION DOMAIN ERROR!");
            printf("\nfunction: %s",e->name);
            printf("\nargument(s): %20.10f %20.10f",e->arg1,e->arg2);
            return 0;
         }
      }
      getch();
      return 0;
   }
}

